﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace PaperProduction.page
{
    /// <summary>
    /// Логика взаимодействия для PaperPage.xaml
    /// </summary>
    public partial class PaperPage : Page
    {
        List<Agent> agentstart = BaseClass.Base.Agent.ToList();
        List<Agent> agFilter;
        public PaperPage()
        {
            InitializeComponent();
            LVPaper.ItemsSource = agentstart;
            CBSort.Items.Add("Наименование");
            CBSort.Items.Add("Размер скидки");
            CBSort.Items.Add("Приоритет агента");
            CBFiltr.Items.Add("Все типы");
            CBFiltr.SelectedIndex = 0;
            List<AgentType> agentTypes = BaseClass.Base.AgentType.ToList();
            for(int i=0; i<agentTypes.Count();i++)
            {
                CBFiltr.Items.Add(agentTypes[i].Title);
            }
        }

        private void TBSaller(object sender, RoutedEventArgs e)
        {

        }

        private void TBPersent(object sender, RoutedEventArgs e)
        {

        }

        public void Filter()
        {
            agFilter = agentstart;
            int i = CBFiltr.SelectedIndex;
            if(i!=0)
            {
                agFilter = agentstart.Where(x => x.AgentTypeID == i).ToList();
            }
            else
            {
                agFilter = agentstart;
            }
            if(!string.IsNullOrWhiteSpace(TBSort.Text))
            {
                agFilter = agentstart.Where(x => x.Title.ToLower().Contains(TBSort.Text)).ToList();         
            }
            LVPaper.ItemsSource = agFilter;      
                   
        }

        private void BTUP(object sender, RoutedEventArgs e)
        {
            if (CBSort.SelectedIndex == 0)
            {
                agFilter.Sort((x, y) => x.ID.CompareTo(y.ID));
                LVPaper.Items.Refresh();
            }
            if (CBSort.SelectedIndex == 1)
            {
                agFilter.Sort((x, y) => x.Title.CompareTo(y.Title));
                LVPaper.Items.Refresh();
            }
            if (CBSort.SelectedIndex == 2)
            {
                agFilter.Sort((x, y) => x.ID.CompareTo(y.ID));
                LVPaper.Items.Refresh();
            }
            if (CBSort.SelectedIndex == 3)
            {
                agFilter.Sort((x, y) => x.Priority.CompareTo(y.Priority));
                LVPaper.Items.Refresh();
            }

        }

        private void BTDown(object sender, RoutedEventArgs e)
        {
            if (CBSort.SelectedIndex == 0)
            {
                agFilter.Sort((x, y) => x.ID.CompareTo(y.ID));
                agFilter.Reverse();
                LVPaper.Items.Refresh();
            }
            if (CBSort.SelectedIndex == 1)
            {
                agFilter.Sort((x, y) => x.Title.CompareTo(y.Title));
                agFilter.Reverse();
                LVPaper.Items.Refresh();
            }
            if (CBSort.SelectedIndex == 2)
            {
                agFilter.Sort((x, y) => x.ID.CompareTo(y.ID));
                agFilter.Reverse();
                LVPaper.Items.Refresh();
            }
            if (CBSort.SelectedIndex == 3)
            {
                agFilter.Sort((x, y) => x.Priority.CompareTo(y.Priority));
                agFilter.Reverse();
                LVPaper.Items.Refresh();
            }
        }

        private void TBSort_TextChanged(object sender, TextChangedEventArgs e)
        {
            Filter();
        }

        private void CBFiltr_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            Filter();
        }

        private void CBSort_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            Filter();
        }
    }
}
